from ctypes import *

print("###########################################################################################################")
print("####     VIRTUALXML CON PYTHON UTILIZANDO      ############################################################")
print("####     FUNCIONES EXPORTADAS WIDE             ############################################################")
print("###########################################################################################################")
print("\r\n")

# Declarar DLL sin extension
vxml = cdll.virtualxml

print(vxml)

baseName = "python_cfdi33_basico"

hXml = vxml.VirtualXML_NewW("3.3")
print("Handler: " + str(hXml))
vxml.VirtualXML_SetLogFileW(hXml, baseName + ".log")
print("VirtualXML_SetLogFile.OK")
vxml.VirtualXML_SetVirtualPACInfoW(hXml, "demo_cibertec", "demo")
print("VirtualXML_SetVirtualPACInfo.OK")

vxml.VirtualXML_SetComprobanteInfo_cfdi33W(hXml,"A","1","%cb_date","99","Contado Comercial","1000.00","50.00","MXN","","1102.00","I","PPD","53050","")
print("VirtualXML_SetComprobanteInfo_cfdi33.OK")

vxml.VirtualXML_SetCfdiRelacionados_cfdi33W(hXml,"04")
print("VirtualXML_SetCfdiRelacionados_cfdi33.OK")
vxml.VirtualXML_AddCfdiRelacionado_cfdi33W(hXml, "FF93C8BE-AF7B-4FC5-8854-6DAE18CFB5B4")
vxml.VirtualXML_AddCfdiRelacionado_cfdi33W(hXml, "D8E18C2F-2859-4927-A0F0-EA3E93642DDC")
vxml.VirtualXML_AddCfdiRelacionado_cfdi33W(hXml, "BE1D4B47-E167-47A3-8049-70D4D43BCBE8")
vxml.VirtualXML_AddCfdiRelacionado_cfdi33W(hXml, "FDBA380A-9732-4FB5-A6CB-5FB4BD831697")
print("VirtualXML_AddCfdiRelacionado_cfdi33.OK")

vxml.VirtualXML_SetEmisorInfo_cfdi33W(hXml,"AAA010101AAA","Empresa de prueba SA de CV","601")
print("VirtualXML_SetEmisorInfo_cfdi33.OK")

vxml.VirtualXML_SetReceptorInfo_cfdi33W(hXml,"CTE940531F58","Cibernetica y Tecnología SA de CV","","","G01")
print("VirtualXML_SetReceptorInfo_cfdi33.OK")

vxml.VirtualXML_AddConcepto_cfdi33W(hXml, "84111506", "SEF500", "1", "H87", "Timbre", "Paquete de 500 timbres fiscales", "500.00", "500.00", "")
print("VirtualXML_AddConcepto_cfdi33.OK")
vxml.VirtualXML_AddConceptoTraslado_cfdi33W(hXml, "500.00", "002", "Tasa", "0.160000", "80.00")
print("VirtualXML_AddConceptoTraslado_cfdi33.OK")

vxml.VirtualXML_AddConcepto_cfdi33W(hXml, "84111506", "SEF250", "2", "H87", "Timbre", "Paquete de 500 timbres fiscales", "250.00", "500.00", "50.00")
vxml.VirtualXML_AddConceptoTraslado_cfdi33W(hXml, "450.00", "002", "Tasa", "0.160000", "72.00")

vxml.VirtualXML_SetImpuestosInfo_cfdi33W(hXml, "152.00", "")
print("VirtualXML_SetImpuestosInfo_cfdi33.OK")
vxml.VirtualXML_AddTraslado_cfdi33W(hXml, "002", "Tasa", "0.160000", "152.00")
print("VirtualXML_AddTraslado_cfdi33.OK")

exitcode = vxml.VirtualXML_ProcesaDocumentoW(hXml, "C:\\Certificados_new2017\\CSD01_AAA010101AAA.cer", "C:\\Certificados_new2017\\CSD01_AAA010101AAA.key", "12345678a", baseName + "_xmlout.xml")
print("VirtualXML_ProcesaDocumento.OK")


vxml.VirtualXML_GetValuesW(hXml, baseName + "_xmlout.out", 0)
vxml.VirtualXML_GetValuesW(hXml, baseName + "_xmlout.ini", 1)

print("\r\n")
print("EXITCODE: " + str(exitcode))

# declarar Valor de Retorno para funcion GetValue como puntero WIDE
vxml.VirtualXML_GetValueW.restype = c_wchar_p

if exitcode == 0:
  for x in range(1, 22):
    print("\t-- GetValue[" + str(x) + "]: " + vxml.VirtualXML_GetValueW(hXml,x))
else:
  print(" >>>>> " + vxml.VirtualXML_GetValueW(hXml,1))
  print(" >>>>> Error en el CFDI:" + vxml.VirtualXML_GetValueW(hXml,2))
  print(" >>>>> Revisar el fichero: " + baseName + ".log")

print("\r\n")
vxml.VirtualXML_Free(hXml)
print("VirtualXML_Free.OK")

print("\r\n")

print("All Done!")
